
%   a)  nacitat obrazok, b) urobit jeho spektrum, c) navrhnut HP a DP,
%   d) prefiltrovat obrazok, e) zobrazit vysledok filtracie
%--------------------------------------------------------------------------

clear all
close all
clc

%   a)

I = imread('cameraman.jpg');  % nacitanie obrazku a nasledne prekonvertovanie do grayscale
x = rgb2gray(I);

%   b)

X = fft2(double(x));   %   vypocet frekvencneho spektra obrazku
X = fftshift(X);       %   preusporiadanie spektra tak, aby v strede boli nizke frekvencie a na okrajoch vysoke

%   c)
%   Vytvorenie pozadovanych prenosovych funkcii. Typy: Hd - Dolna Priepust,
%   Hh - Horna Priepust, PZ - Pasmova Zadrz, PP - Pasmova Priepust

Hd = zeros(256,256); Hd(256/4:256-256/4,256/4:256-256/4) = 1; %Hd(6:7,6:7) = 0.5;
Hh = 1 - Hd;
PZ = ones(256,256); PZ(256/6:5*256/6,256/6:5*256/6) = 0; PZ(256/3:2*256/3,256/3:2*256/3) = 1; 
PP = 1 - PZ;

%figure, imshow(x)
figure, imshow(X)
%figure, imshow(Hd)
%figure, imshow(Hh)

%   d)
%   Filtrovanie obrazku danymi prenosovymi funkciami.
Yd = Hd.*X;
figure('Name','Spektrum po filtrovani s DP','NumberTitle','off'), imshow(Yd);

Yh = Hh.*X;
figure('Name','Spektrum po filtrovani s HP','NumberTitle','off'), imshow(Yh);

Ypz = PZ.*X;
figure('Name','Spektrum po filtrovani s PZ','NumberTitle','off'), imshow(Ypz);

Ypp = PP.*X;
figure('Name','Spektrum po filtrovani s PP','NumberTitle','off'), imshow(Ypp);

% Dalsi mozny sposob filtracie je pomocou integrovanej funkcie filter2.
% Tu vsak treba impulzovu odpoved filtra, ktoru ziskame z prenosovej funkcie funkciou fsamp2.
% Pre viac info pouzi Help.
%hd = fsamp2(Hd);
%Yd = filter2(hd,X);

%   e)
%   Ziskanie obrazku v casovej resp. v obrazovej oblasti.
%   Postup: je potrebne spatne preusporiadanie spektra (ifftshift), zvysenie
%   presnosti na double, spatna furierka (ifft2) a ziskanie realnej casti z
%   komplexneho vysledku (abs).

yd = abs(ifft2(double(ifftshift(Yd))));
figure('Name','Obrazok po filtrovani s DP','NumberTitle','off'); 
imshow(yd,[],'InitialMagnification','fit')

yh = abs(ifft2(double(ifftshift(Yh))));
figure('Name','Obrazok po filtrovani s HP','NumberTitle','off'); 
imshow(yh,[],'InitialMagnification','fit');

ypz = abs(ifft2(double(ifftshift(Ypz))));
figure('Name','Obrazok po filtrovani s PZ','NumberTitle','off'); 
imshow(ypz,[],'InitialMagnification','fit');

ypp = abs(ifft2(double(ifftshift(Ypp))));
figure('Name','Obrazok po filtrovani s PP','NumberTitle','off'); 
imshow(ypp,[],'InitialMagnification','fit');

%--------------------------------------------------------------------------
%   f)  !!!!!!!!!!!!!! BONUS !!!!!!!!!!!!!!!!!
%   zaujimave prenosove funkcie
%   pozn.: je potrebne aby boli v priecinku aj subory: lp.m, hp.m a bp.m

Hd = lp(256,0.05);      %   ziskanie prenosovych funkcii o rozmere 256x256, 
Hh = hp(256,0.01);      %   dalsie parametre su cut-off frequency
PP = bp(256,0.9,0.1);

%   Dalsi postup je taky isty ako v bodoch d) a e).

Yd = Hd.*X;
figure('Name','Spektrum po filtrovani s DP BONUS','NumberTitle','off'); 
imshow(Yd);

Yh = Hh.*X;
figure('Name','Spektrum po filtrovani s HP BONUS','NumberTitle','off'); 
imshow(Yh);

Ypp = PP.*X;
figure('Name','Spektrum po filtrovani s PP BONUS','NumberTitle','off'); 
imshow(Ypp);
            
yd = abs(ifft2(double(ifftshift(Yd))));
figure('Name','Obrazok po filtrovani s DP BONUS','NumberTitle','off'); 
imshow(yd,[],'InitialMagnification','fit');

yh = abs(ifft2(double(ifftshift(Yh))));
figure('Name','Obrazok po filtrovani s HP BONUS','NumberTitle','off'); 
imshow(yh,[],'InitialMagnification','fit');

ypp = abs(ifft2(double(ifftshift(Ypp))));
figure('Name','Obrazok po filtrovani s PP BONUS','NumberTitle','off'); 
imshow(ypp,[],'InitialMagnification','fit');
