function filter_matrix = lp(order, cutoff);
% lp --> Creates a low pass filter
%	 The filter has size (order x order)
%	 and cutoff specified between 0 and 1

%Create desired frequency response
[f1,f2] = freqspace(order,'meshgrid');
d = find(f1.^2+f2.^2 < cutoff^2);
Hd = zeros(order);
Hd(d) = ones(size(d));

% Design the filter's impulse response
filter_matrix = fsamp2(Hd);